<template>
  <div class="project-repository-section">
    <div class="container-fluid">
      <div class="row">
        <div class="col-sm-12 col-lg-6 offset-lg-3">
          <div class="title">
            {{ repository.displayName }}
            <div
              class="branch-selector"
              v-if="branches.length > 0"
              @click="toggleSelectorOpen"
            >
              {{ selectedBranch }}
              <div class="branches" v-if="selectorOpen">
                <div
                  v-for="(branch, index) in branches"
                  :key="index"
                  @click="selectBranch(branch)"
                >
                  {{ branch }}
                </div>
              </div>
              <i v-if="repoOpen" class="fas fa-caret-down"></i>
            </div>
          </div>
          <div class="title-label">
            https://git.scepter.dev/{{ this.project.name }}/{{
              this.repository.name
            }}.git
          </div>
          <keep-alive>
            <repository-files
              v-if="repoOpen"
              :branch="selectedBranch"
              :project="project.name"
              :repository="this.repository"
            ></repository-files>
          </keep-alive>
          <div class="repository-credentials">
            <div class="title">
              Credentials
            </div>
            <div class="repository-credentials-list">
              <div
                class="repository-credential"
                v-for="credential in this.repository.credentials"
                :key="credential.id"
              >
                <div class="lock">
                  <i class="fas fa-lock"></i>
                </div>
                <div class="name">
                  {{ credential.username }}
                </div>
                <div
                  class="delete"
                  @click="deleteCredentialConfirmation(credential)"
                >
                  <i class="fas fa-trash"></i>
                </div>
              </div>
            </div>
            <button class="button" @click="addCredential">
              Add Credential
            </button>
          </div>
          <div
            class="openCloseRepo"
            :class="{ opened: repoOpen }"
            @click="repoOpen = !repoOpen"
          >
            <i class="fas fa-chevron-down"></i>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import CreateCredential from "../../../components/modals/CreateCredential";
import RepositoryFiles from "../RepositoryFiles";
import { mapActions } from "vuex";
export default {
  components: {
    RepositoryFiles
  },
  mounted() {
    this.getBranches();
  },
  data() {
    return {
      branches: [],
      selectorOpen: false,
      selectedBranch: null,
      repoOpen: true
    };
  },
  props: {
    project: {
      required: true
    },
    repository: {
      required: true
    }
  },
  methods: {
    ...mapActions("projectModule", ["deleteCredential"]),
    getBranches() {
      this.$apiService
        .getBranches(this.project.name, this.repository.name)
        .then(response => {
          this.branches = response.data.map(item => {
            const array = item.split("/");
            return array[array.length - 1];
          });
          this.selectedBranch = this.branches[0];
        });
    },
    selectBranch(branch) {
      this.selectedBranch = branch;
    },
    toggleSelectorOpen() {
      if (!this.repoOpen) return;
      this.selectorOpen = !this.selectorOpen;
    },
    addCredential() {
      this.$modal.show(CreateCredential, {
        repository: this.repository
      });
    },
    deleteCred(credential) {
      this.deleteCredential({
        repository: this.repository.id,
        credential
      }).then(() => {
        this.$modal.hide("dialog");
      });
    },
    deleteCredentialConfirmation(credential) {
      this.$modal.show("dialog", {
        title: "Delete credentials",
        text: "Are you sure you want to delete these credentials?",
        buttons: [
          {
            title: "Delete",
            default: true,
            handler: () => this.deleteCred(credential)
          },
          {
            title: "Cancel"
          }
        ]
      });
    }
  }
};
</script>

<style lang="scss">
.project-repository-section {
  padding-top: 20px;
  position: relative;
  overflow: hidden;

  .repository-credentials {
    margin-bottom: 40px;

    .title {
    }

    .repository-credentials-list {
      width: 100%;
      background-color: #f3f3f3;
      border: 1px solid #e5e5e5;
      border-radius: 8px;
      overflow: hidden;

      .repository-credential {
        display: flex;
        align-items: center;
        border-radius: 8px;
        &.add-credential {
          font-size: 12px;
        }
        .lock {
          background-color: #9aff97;
          border: 1px solid #14a817;
          color: #14a817;
          padding-left: 10px;
          padding-right: 10px;
          height: 40px;
          display: flex;
          justify-content: center;
          align-items: center;
        }

        .name {
          flex: 1;
          height: 40px;
          line-height: 40px;
          background-color: transparent;
          border: 1px solid transparent;
          padding-left: 10px;
          padding-right: 10px;
          font-weight: 600;
          color: #919191;
        }
        .delete {
          width: 40px;
          height: 40px;
          display: flex;
          justify-content: center;
          align-items: center;
          color: #b2b2b2;
          &:hover {
            color: #c80000;
            cursor: pointer;
          }
        }
        &:first-child {
          .lock {
            border-top-left-radius: 8px;
          }
          .name {
            border-top-right-radius: 8px;
          }
        }
        &:last-child {
          .lock {
            border-bottom-left-radius: 8px;
          }
          .name {
            border-bottom-right-radius: 8px;
          }
        }
      }
    }
  }

  .openCloseRepo {
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 0);
    color: white;
    width: 25px;
    height: 20px;
    background-color: #ffd338;
    display: flex;
    justify-content: center;
    align-items: center;

    i {
      font-size: 15px;
    }

    transition: bottom 0.1s ease-out;

    &:hover {
      cursor: pointer;
      bottom: -4px;
    }

    &.opened {
      i {
        transform: rotate(180deg);
      }
    }
  }

  .title {
    font-size: 24px;
    font-weight: bold;
    color: #4c4e57;

    .branch-selector {
      margin-left: 10px;
      user-select: none;
      display: inline-block;
      font-size: 14px;
      background-color: #ffd338;
      border: 2px solid #ffdf6f;
      border-radius: 8px;
      padding-left: 5px;
      padding-right: 5px;
      color: #947301;
      position: relative;

      &:hover {
        cursor: pointer;
      }

      i {
        margin-left: 10px;
      }

      .branches {
        position: absolute;
        top: calc(100% + 10px);
        left: 0;
        width: 100%;
        background-color: #ffd338;
        border: 2px solid #ffdf6f;
        border-radius: 8px;

        & > div {
          padding-left: 5px;
          padding-right: 5px;
        }
      }
    }
  }

  .title-label {
    font-weight: 600;
    color: #666768;
    margin-bottom: 20px;
  }

  border-bottom: 1px solid #dbdbdb;
}

#app {
  &.darkMode {
    .project-repository-section {
      border-bottom-color: #3e4756;

      .title {
        color: #687782;
      }

      .title-label {
        color: #8998a3;
      }

      .repository-credentials {
        .repository-credentials-list {
          background-color: #293039;
          border: 1px solid #25282e;
          margin-bottom: 15px;
          .repository-credential {
            .lock {
              background-color: #9aff97;
              border: 1px solid #14a817;
              color: #14a817;
            }

            .name {
              background-color: transparent;
              border: 1px solid transparent;
              color: #4f5e75;
            }
            .delete {
              color: #687782;
              &:hover {
                color: #c80000;
              }
            }
          }
        }
      }
    }
  }
}
</style>
